#ifndef PC6001V_H_INCLUDED
#define PC6001V_H_INCLUDED

#include <memory.h>

#include <SDL.h>


/////////////////////////////////////////////////////////////////////////////
// ӥɥץ (פʹܤϥȥȤ)
/////////////////////////////////////////////////////////////////////////////
// ˥⡼ɤλ
#define	USEMONITOR


/////////////////////////////////////////////////////////////////////////////
// С
/////////////////////////////////////////////////////////////////////////////
#define	VERSION		"1.09"


/////////////////////////////////////////////////////////////////////////////
// ץ 
/////////////////////////////////////////////////////////////////////////////
#define	DEFAULT_MODEL			(60)				/*  60:PC-6001 62:PC-6001mk2 66:PC-6601 64:PC-6001mk2SR 68:PC-6601SR */
#define	DEFAULT_EXTRAM			(1)					/* ĥRAM 0:ʤ 1: */
#define	DEFAULT_REPEAT			(70)				/* ԡȤδֳ(ñ:ms 0̵) */
#define	DEFAULT_KEYBOARD		(FALSE)				/* PS/2ܡɻȤ? TRUE:PS/2 FALSE:USB */
#define	DEFAULT_SAMPLE_RATE		(44100)				/* ץ󥰥졼 */
#define	SOUND_BUFFER_SIZE		(4)					/* ɥХåեĹΨ(ĹVSYNC) */
#define	DEFAULT_MASTERVOL		(50)				/* ޥ */
#define	DEFAULT_PSGVOL			(80)				/* PSG */
#define	DEFAULT_VOICEVOL		(100)				/*  */
#define	DEFAULT_TAPEVOL			(20)				/* TAPE˥ */
#define	DEFAULT_TURBO			(TRUE)				/* Turbo TAPE Yes:ͭ No:̵ */
#define	DEFAULT_BOOST			(FALSE)				/* BoostUp Yes:ͭ No:̵ */
#define DEFAULT_MAXBOOST60		(9)					/* BoostUpΨ(N60⡼) */
#define DEFAULT_MAXBOOST62		(5)					/* BoostUpΨ(N60m/N66⡼) */
#define	DEFAULT_FDD				(0)					/* FDD³ */
#define	DEFAULT_COLOR_MODE		(16)				/* 顼⡼ 8:8bit 16:bit 24:24bit */
#define	DEFAULT_MODE4_COLOR		(1)					/* ⡼ɣ顼⡼ 0: 1:/ 2:/ 3:ԥ/ 4:/ԥ */
#define	DEFAULT_SCANLINE		(FALSE) 			/* 饤 TRUE: FALSE:ʤ */
#define	DEFAULT_SCANLINEBR		(50)				/* 饤 (0-100)% */
#define	DEFAULT_DISPNTSC		(TRUE) 				/* 4:3ɽ TRUE:ͭ FALSE:̵ */
#define	DEFAULT_FRAMESKIP		(0)					/* ե졼ॹå */

#define	CPU_CLOCK				(3993600)			/* CPUå(Hz) */
#define	VSYNC_HZ				(60)				/* VSYNCȿ */
#define	DEFAULT_TIMER_HZ		(487.5)				/* ޳߼ȿ  */
#define	UTIMER_HZ				(DEFAULT_TIMER_HZ*4)
#define	DEFAULT_BAUD			(1200)				/* CMTܡ졼  */
#define	DEFAULT_CMT_HZ			(DEFAULT_BAUD/12)	/* CMT߼ȿ  (1byte -> StartBit:1 + DataBit:8 + StopBit:3 = 12bits Ȥ) */
#define	PSG_CLOCK				(CPU_CLOCK/2)		/* PSGå(Hz) */

//#define	DEFAULT_FPS_CNT			(TRUE)			/* FPS TRUE:ɽ FALSE:ɽ */

// SDLեѥץ
#define SDLOP_SCREEN			(SDL_HWSURFACE | SDL_DOUBLEBUF | SDL_HWACCEL)
#define SDLOP_SURFACE			(SDL_SWSURFACE | SDL_HWACCEL)

/////////////////////////////////////////////////////////////////////////////
// Ƽǥ쥯ȥ̾ 
/////////////////////////////////////////////////////////////////////////////
#define	ROM_DIR			"rom"			/* ROM᡼ */
#define	TAPE_DIR		"tape"			/* TAPE᡼ */
#define	DISK_DIR		"disk"			/* DISK᡼ */
#define	EXTROM_DIR		"extrom"		/* ĥROM᡼ */
#define	IMAGE_DIR		"img"			/* ʥåץå */
#define	FONT_DIR		"font"			/* ե */
#define	WAVE_DIR		"wave"			/* WAVEե */


/////////////////////////////////////////////////////////////////////////////
// Ƽե̾ 
/////////////////////////////////////////////////////////////////////////////
#define	CONF_FILE		"pc6001v.ini"	/* ե */
#define	PRINTER_FILE	"printer.txt"	/* ץ󥿽ϥե */
#define	DOKODEMO_FILE	"dokodemo.dds"	/* ɤǤSAVEե */
#define	SERIAL_FILE		"serial.txt"	/* ꥢϥե */
#define	SAVE_FILE		"_csave.p6t"	/* TAPE(CSAVE)ե */
#define	FONTZ_FILE		"fontz12.png"	/* Ⱦѥեȥե */
#define	FONTH_FILE		"fonth12.png"	/* ѥեȥե */

#define	SUBCPU60		"subcpu.60"		/* CPU ROM(PC-6001) */
#define	SUBCPU62		"subcpu.62"		/* CPU ROM(PC-6001mk2) */
#define	SUBCPU66		"subcpu.66"		/* CPU ROM(PC-6601) */

#define	FONTVDG			"cgrom60s.60"	/* VDGեȥե */

/////////////////////////////////////////////////////////////////////////////
// ,
/////////////////////////////////////////////////////////////////////////////
#ifdef WIN32
#include <windows.h>
#else
typedef int BOOL;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
#endif

#ifndef FALSE
#define FALSE	(0)
#endif

#ifndef TRUE
#define TRUE	(1)
#endif

#ifndef MAX_PATH
#define	MAX_PATH	(260)
#endif


/////////////////////////////////////////////////////////////////////////////
// ѥޥ
/////////////////////////////////////////////////////////////////////////////
#define STATIC_CAST(t, o)	static_cast<t> (o)

#define FGETBYTE(fp)		((BYTE)fgetc(fp))
#define FGETWORD(fp)		((WORD)(((BYTE)fgetc(fp))|((BYTE)fgetc(fp)<<8)))
#define FGETDWORD(fp)		((DWORD)(((BYTE)fgetc(fp))|((BYTE)fgetc(fp)<<8)|((BYTE)fgetc(fp)<<16)|((BYTE)fgetc(fp)<<24)))
#define FPUTBYTE(data,fp)	fputc(data&0xff,fp)
#define FPUTWORD(data,fp)	{ fputc(data&0xff,fp); fputc((data>>8)&0xff,fp); }
#define FPUTDWORD(data,fp)	{ fputc(data&0xff,fp); fputc((data>>8)&0xff,fp); fputc((data>>16)&0xff,fp); fputc((data>>24)&0xff,fp); }

#define CTODW(a,b,c,d)		((DWORD)(((BYTE)(a))|(((DWORD)((BYTE)(b)))<<8)|(((DWORD)((BYTE)(c)))<<16)|(((DWORD)((BYTE)(d)))<<24)))

#if SDL_BYTEORDER == SDL_LIL_ENDIAN

#define GET3BYTE(a,b,c,p)	{ a = *((BYTE *)p++); b = *((BYTE *)p++); c = *((BYTE *)p++); }
#define PUT3BYTE(a,b,c,p)	{ *((BYTE *)p++) = a; *((BYTE *)p++) = b; *((BYTE *)p++) = c; }
#define BTODW(a,b,c,d)		((DWORD)(((BYTE)(a))|(((DWORD)((BYTE)(b)))<<8)|(((DWORD)((BYTE)(c)))<<16)|(((DWORD)((BYTE)(d)))<<24)))
#define DWTOB(s,a,b,c,d)	{ a = (BYTE)((s>>24)&0x000000ff); b = (BYTE)((s>>16)&0x000000ff); c = (BYTE)((s>>8)&0x000000ff); d = (BYTE)(s&0x000000ff); }

#else

#define GET3BYTE(a,b,c,p)	{ c = *((BYTE *)p++); b = *((BYTE *)p++); a = *((BYTE *)p++); }
#define PUT3BYTE(a,b,c,p)	{ *((BYTE *)p++) = c; *((BYTE *)p++) = b; *((BYTE *)p++) = a; }
#define BTODW(a,b,c,d)		((DWORD)(((BYTE)(d))|(((DWORD)((BYTE)(c)))<<8)|(((DWORD)((BYTE)(b)))<<16)|(((DWORD)((BYTE)(a)))<<24)))
#define DWTOB(s,a,b,c,d)	{ d = (BYTE)((s>>24)&0x000000ff); c = (BYTE)((s>>16)&0x000000ff); b = (BYTE)((s>>8)&0x000000ff); a = (BYTE)(s&0x000000ff); }

#endif

#define	COUNTOF(arr)		(int)(sizeof(arr)/sizeof((arr)[0]))

#ifndef ZeroMemory
#define ZeroMemory(d,l)	memset((d), 0, (l))
#endif

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif
#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif

// MacʸѴ ShiftJIS -> UTF-8
#ifdef __APPLE__
#define FOPENEN(a,b)	fopen(Sjis2UTF8(a),b)
#else
#define FOPENEN(a,b)	fopen(a,b)
#endif

/////////////////////////////////////////////////////////////////////////////
// SDL 桼٥
/////////////////////////////////////////////////////////////////////////////
#define SENDEVENT(etype)		{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			SDL_PushEvent( &ev ); }

#define SENDEVENT1(etype,data)	{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			ev.user.code = data;	\
			SDL_PushEvent( &ev ); }

#define SENDEVENT2(etype,d1,d2)	{						\
			SDL_Event ev;								\
			ev.type = etype;							\
			ev.user.code = ((d1)<<16)|((d2)&0xffff);	\
			SDL_PushEvent( &ev ); }

#define SENDEVENTP(etype,pnt)	{	\
			SDL_Event ev;			\
			ev.type = etype;		\
			ev.user.data1 = pnt;	\
			SDL_PushEvent( &ev ); }


#define SDL_DRAWSCREEN	(SDL_USEREVENT)
#define SDL_FPSUPDATE	(SDL_USEREVENT+1)
#define SDL_RESTART		(SDL_USEREVENT+2)

#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
#define SDL_DEBUGMODEBP	(SDL_USEREVENT+10)
#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //


/////////////////////////////////////////////////////////////////////////////
// ǥХåط
/////////////////////////////////////////////////////////////////////////////
// 1ˤ
#define KEY_LOG		0	/* ϴط */
#define MEM_LOG		0	/* ط */
#define TAPE_LOG	0	/* TAPEط */
#define P6T2_LOG	0	/* P6T2ط */
#define DISK_LOG	0	/* DISKط */
#define FDC_LOG		0	/* FDCط */
#define D88_LOG		0	/* D88ط */
#define PSG_LOG		0	/* PSGط */
#define INTR_LOG	0	/* ߴط */
#define CPU_LOG		0	/* CPUط */
#define SUB_LOG		0	/* CPUط */
#define PPI_LOG		0	/* 8255ط */
#define SND_LOG		0	/* Soundط */
#define GRP_LOG		0	/* ط */
#define OSD_LOG		0	/* OS¸ط */
#define TIC_LOG		0	/* 塼ط */
#define INI_LOG		0	/* INIط */
#define CON_LOG		0	/* 󥹥ȥ饯ط */
#define IO_LOG		0	/* I/Oط */
#define WIN_LOG		0	/* ɥط */
#define CONST_LOG	0	/* 󥹥ȥ饯ǥȥ饯ط */
#define VOI_LOG		0	/* ط */

#if KEY_LOG || MEM_LOG || TAPE_LOG || P6T2_LOG || DISK_LOG || D88_LOG || FDC_LOG || PSG_LOG || INTR_LOG || CPU_LOG || SUB_LOG || PPI_LOG || SND_LOG || GRP_LOG || OSD_LOG || TIC_LOG || INI_LOG || CON_LOG || IO_LOG || WIN_LOG || CONST_LOG || VOI_LOG
 #define LOG_ON
#endif

#if defined(LOG_ON)
 #include <stdio.h>
 #define PRINTD(m,s)			{ if( m ){ fprintf( stdout, (s) );							fflush( stdout); } }
 #define PRINTD1(m,s,a)			{ if( m ){ fprintf( stdout, (s), (a) );						fflush( stdout); } }
 #define PRINTD2(m,s,a,b)		{ if( m ){ fprintf( stdout, (s), (a), (b) );				fflush( stdout); } }
 #define PRINTD3(m,s,a,b,c)		{ if( m ){ fprintf( stdout, (s), (a), (b), (c) );			fflush( stdout); } }
 #define PRINTD4(m,s,a,b,c,d)	{ if( m ){ fprintf( stdout, (s), (a), (b), (c), (d) );		fflush( stdout); } }
 #define PRINTD5(m,s,a,b,c,d,e)	{ if( m ){ fprintf( stdout, (s), (a), (b), (c), (d), (e) );	fflush( stdout); } }
#else
 #define PRINTD(m,s)
 #define PRINTD1(m,s,a)
 #define PRINTD2(m,s,a,b)
 #define PRINTD3(m,s,a,b,c)
 #define PRINTD4(m,s,a,b,c,d)
 #define PRINTD5(m,s,a,b,c,d,e)
#endif


/////////////////////////////////////////////////////////////////////////////
// ¸ŪʤΤȤ
/////////////////////////////////////////////////////////////////////////////
// ե뼫ưλ饹
//class cFile {
//private:
//	FILE *fp;
//	
//public:
//	cFile( FILE *f ) : fp( f ){}
//	~cFile(){ if( fp ) fclose( fp ); }
//	operator FILE * () const { return fp; }
//};


#endif	// PC6001V_H_INCLUDED
